\documentclass[twoside, titlepage]{article}

%\usepackage{/usr/local/common/TEXINPUTS/verimagreport}
\usepackage{verimagreport}
\usepackage{ifthen}

%\NeedsTeXFormat{LaTeX2e}
\listfiles   


% \documentclass[11pt]{article} 
% \usepackage[latin1]{inputenc} 

% \usepackage[T1]{fontenc} 

\usepackage{alltt}
\usepackage{wrapfig}

%Check if we are compiling under latex or pdflatex
\ifx\pdftexversion\undefined
  \usepackage[dvips]{graphicx}
\else
  \usepackage[pdftex]{graphicx}
  \pdfinfo{ 
    /Title (The Lurette  User Guide)
    /Creator (latex)
    /Author  (Erwan Jahier)
  }
\fi

\usepackage{boxedminipage}
\usepackage{amsfonts,amssymb,amsmath}
\usepackage{color}
\input{/home/jahier/TeXinputs/xcolor-ex}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% HTMl stuff 
\usepackage{hyperlatex}
%\usepackage[colorlinks, linkcolor=blue,pdftex]{hyperref}

\htmltitle{The Lurette V2 User Guide}
%\htmladdress{erwan.jahier@imag.fr}
\usepackage{frames}
   
\htmldirectory{html}

\setcounter{htmldepth}{3}
\setcounter{htmlautomenu}{3}

%\htmlpanel{1}

% \htmlpanelfield{Table of contents}{tableofcontents}
% \htmlpanelfield{Contents}{hlxcontents}

% \htmlpanelfield{Index}{hlxindex}

%\HlxPrevUrl

\W\usepackage{sequential}
\htmlrule


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\input{macros}
\input{/home/jahier/lurette/doc/version}


 

\title{The Lurette V2 User Guide}
\author{Erwan Jahier}

\date{Initial version:  March 12, 2004 \\
Last update: \today \\
Software Version: \version}



\reportnumber{TR-2004-5}

\shorttitle{The Lurette V2 User Guide}

\abstract{
Lurette is an Automatic Test Generator for \emph{Reactive Programs}.
It is automated in two main ways.  Realistic input sequences are
generated from non-deterministic formal descriptions of the
\emph{System Under Test} Environment properties (pre-conditions).
The test decision is done with a formal description of the 
desired properties -- correct behaviours -- of the SUT (post-conditions). \\ \\
%
Of course, formal verification should be used whenever possible.
However, because program verification is undecidable, testing will
always be necessary.  Lurette therefore concentrates on cases where
formal verification is limited: programs and complex properties,
in particular involving numerical aspects.\\ \\
%
Lurette has been redesigned from scratch.  This document is a User
Guide for this new version of Lurette. Its provides an --
hopefully -- exhaustive description of its features, as well as a
tutorial.
}

\keywords{Reactive systems, validation, automatic test case generation, lurette, lustre}

\reviewers{Nicolas Halbwachs}

%\notes{a note}


%--------------------------------------------------------------------
%--------------------------------------------------------------------
\begin{document}


\maketitlepage
%\maketitle


% Lurette has been designed for \emph{Reactive programs}, but could
% actually be used for testing any kind of programs with a well defined
% interface.

\newpage
\tableofcontents


%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage
\section{Introduction}
 

The Lurette testing tool is based on the principles described
in~\cite{lurette98}. We first recall those principles, before
describing the new tool into more details.




\paragraph{What kind of testing?}
Of course, formal verification should be used whenever possible.
However, because program verification is undecidable, testing will
always be necessary. In this work we concentrate on cases where
formal verification cannot be applied, i.e.,
\begin{itemize}
\item for complex programs and properties, involving numerical aspects;
\item for black-box programs, (a part of) the source of which is not available or
written in a low level language.
\end{itemize}

The last point means that Lurette will focus on functional testing:
the program will be a black box, for which we want to check some
properties.

\paragraph{Testing reactive systems: specific problems.}

In addition to usual problems of test case generation --- selection of realistic
test cases, oracle and diagnosis, defining and improving coverage ---, testing 
reactive systems  raises some specific problems:
\begin{itemize}
\item test cases are not just input values, but {\em sequences\/} of input values,
and these sequences can be very long;
\item a reactive system is often intended to control its environment. As a
consequence, realistic test sequences can depend on the behaviour of the System
Under Test (SUT). More precisely, the selection of an input value, at a given
sequence point, can depend on the reaction (previous outputs) of the SUT to the
previous elements of the sequence. Hence, realistic sequences cannot be generated
off-line, and the SUT must be involved in the generation.
\end{itemize}

\paragraph{Testing reactive systems: the proposed solution.}
 \cite{lurette98} proposed to generate test sequences from a
user-given specification of realistic (or ``interesting'') scenarios.
Such a specification is a non-deterministic description of sequences
involving both input and output variables of the SUT.  The only
restriction is that the constraints on inputs $i$, at a given point
of a sequence, may only depend on the {\em past} values of outputs
$o$. Moreover, the user can also provide another specification, which
describes correct behaviours or desired properties of the SUT.

Lurette generates input sequences as follows: it first selects a
input vector $i$ satisfying the Environment specification $\Sigma$;
then it provides the vector $i$ to the SUT for one reaction, and gets
back the corresponding output vector $o$; $i$ and $o$ are checked
against the oracle $\Omega$; then the internal state of $\Sigma$ and
$\Omega$ are updated according to $i$ and $o$, and a new step can
start.

\paragraph{Description of non-deterministic behaviours.}

An important point is the way behaviours are specified. Basically,
such a specification behaves as an automaton, providing constraints
on $i$ according to its internal state, and moving from state to
state according to the current values of $i$ and $o$. In the previous
version of Lurette, this specification was an observer written in
Lustre. In the new version, we want to allow various formalisms for
that, because Lustre observers are neither always convenient, nor
powerful enough: for instance, it is often interesting to drive the
generation using weights or probabilities.  This why the tool is
organised around the intermediary language Lucky, into which other
formalisms can be translated.  Lucky is not described in this
document; please refer the Lucky Reference Manual~\cite{lucky-man}
for more information.

% \paragraph{Plan.}
 

\newpage 
\section{The principles }
\label{lurette-func}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{Describing and simulating the System Under Test (SUT) Environment}



\paragraph{SUT Input sequence generation.}

The main challenge to automate the testing process is to able to
automate the generation of \emph{realistic} input sequences to feed
the SUT. In other words, we need an executable model of the
environment which inputs are the SUT outputs, and which outputs are
the SUT inputs. 


Note that realistic input sequences can not be generated off-line,
since the SUT generally influences the behaviour of the environment it
is supposed to control, and vice-versa. Imagine, for example, a
heater controller which input is the temperature in the room, and
which output is a Boolean signal telling the heater whether to heat
or not.

In the first Lurette prototype, the SUT environment behaviour was
described by Lustre observers which were specifying what realistic
SUT inputs should be. In other words, the environment was modelled by
a set of (linear) constraints over Boolean and numeric variables.
The work of Lurette was to solve those constraints, and to draw a
value among the solutions to produce one SUT input vector.

But, from a language point of view, Lustre observers
happen to be too restrictive, in particular to express sequences of
different testing scenarios, or to have some control on the
probabilistic distribution of the drawn solution.  It was precisely
to overcome those limitations that a new language, Lucky, was
designed. 


\paragraph{The Lucky language.}
A Lucky program is an automaton whose transitions define the
reactions of the machine. More precisely, each transition is
associated to (1) a set of constraints (a formula) that defines the
set of the possible outputs, and (2) a weight that defines the
relative probability for each transitions to be taken (i.e., to be used
to produce the output vector for the current step).
%
Please refer to the Lucky language reference manual~\cite{lucky-man}
for more information. 


\paragraph{The Lutin Language.}
One of the goal when designing Lucky was to have a language with a
simple operational semantics (it is a simple interpreted automaton)
that is sufficiently general to model any non-deterministic formal
description. 
%
In particular, the Synchronous team, at Verimag designed another
language, Lutin~\cite{lutin-slap}, which compiles into Lucky.  Lutin
also aims at describing and simulating non-deterministic systems, but
it is based on regular expressions instead of an explicit automaton,
which generally makes the description of non-deterministic systems
easier.
%
Please refer to the Lutin language reference manual~\cite{lutin-man}
for more information.  


\paragraph{Lustre observers.}
Moreover, a gateway from Lustre observers to Lucky programs can
easily be done: it will result in a somewhat degenerated Lucky
automaton with one explicit control state and one (looping)
transition labelled by the Lustre observer equations.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{The Test Oracle}

The second thing that needs to be automated in the testing process is
the test result perusal. In other words, we need to be able to decide
automatically whether or not the test succeeded. To do that, we will
use exactly the same technique as in the first Lurette prototype:
namely, via the use of \emph{Lustre observers}.  A Lustre observer is
a Lustre program that returns exactly one Boolean variable. It lets
one express any safety property -- but no liveness property.



 Users therefore need to write a Lustre (or a Scade) program which
inputs are the SUT inputs and outputs, and which output is a single
Boolean that is true if and only if the test vectors are correct
w.r.t. a given property. That property can be, for example, a
property that a verification tool failed to prove -- which is precisely
when testing techniques are useful.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{The Lurette testing process}
We recall now how the different entities (SUT, oracle, environment)
work all together inside Lurette.



\begin{figure}[h]
%\vspace{-2cm}
\begin{center}
  \mbox{ \scalebox{.45}{\input{objs/lurette-start}}}
\end{center}
  \caption{Lurette start-up.}
  \label{lurette-start}
\end{figure}



Figure~\ref{lurette-start} shows what happens when Lurette starts up.
%
Since the environment outputs serve as SUT inputs, and SUT outputs
serve as environment inputs (the first step excepted), in order to be
able to start such a looped design, one entity have to start first.
The choice has been made that the environment will.  This means that
a valid environment for Lurette is one that can generate values
without any input at the first instant.

The role of {\tt boot} keyword of Figure~\ref{lurette-start} is
precisely to indicate that the environment is indeed starting first;
once the environment received the {\tt boot} signal, it
(non-deterministically) produces an output vector $I$, which will be
used by the SUT. $try \ I$ means that once one step is done in the
SUT to compute its output $O$, the previous state of the SUT is
immediately restored. This allows several input vectors $I$ to be
tried at each step, to perform a kind of \emph{thick} test. In
Figure~\ref{lurette-start}, the different tries are distinguished
thanks to the index  $i$. Hence, at the $i^{th}$ tries, the
vectors $I_i$ and $O_i$, respectively produced by the environment and
the SUT, are tried in the oracle. 



\begin{figure}[h]
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.45}{\input{objs/lurette-step}}}
  \caption{Lurette steps \label{lurette-step}}
\end{minipage}
%
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.45}{\input{objs/lurette-try}}}
  \caption{Lurette tries.}
  \label{lurette-try}
\end{minipage}

\end{figure}


% \begin{wrapfigure}[7]{l}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-step.pstex_t}}}
%   \caption{Lurette steps \label{lurette-step}}
% \end{wrapfigure}
% %
% \begin{wrapfigure}[0]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}




Once a sufficient number of tries has been done (the thickness of
the test is one of the Lurette parameters users have control on, cf.
Section~\ref{test-parameters}), one index is chosen, say $j$, and the
step corresponding to that index is really\footnote{is the sense that
  the previous state of machines is not restored this time.} done
(Figure~\ref{lurette-step}). Note that since the SUT and the oracle
are deterministic machines, we just need to give them the vector
$I_j$ and $O_j$ once more. But this is not true for the environment,
which is non-deterministic; that is the reason why we give it the index
$j$; of course, this means that the environment interpreter needs to
remember which index led to which internal state.



% \begin{wrapfigure}[4]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}



Then the process continues as in Figure~\ref{lurette-start}; the only
difference, as shown in Figure~\ref{lurette-try}, is that the
environment is fed with the SUT output vector $O_j$ which was
elected at the previous step (instead of {\tt boot~i}).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\newpage

\section{The tool}

\subsection{The XLurette Main window parameters (obselete)}
\label{test-parameters}



%\subsubsection{The XLurette Main window parameters}

The most important test parameters can be set directly from the main
Xlurette window. A snapshot of the part of the main window that is
dedicated to the setting of test parameters is shown in
Figure~\ref{main-window-part} (For a snapshot of the whole Main
window, see e.g., Figure~\ref{lurette1}). In the following, we
describe each of those parameters in turn.



\begin{figure}[h]
  \begin{center}
    \begin{minipage}[c]{\textwidth}
      \begin{center}
       \includegraphics[width=\textwidth]{main-window-part1.jpg}
      \end{center}
    \end{minipage}
  \end{center}
  \caption{Part of the main  window.}
  \label{main-window-part}
\end{figure}


\subsubsection{The SUT}

The first line in Figure~\ref{main-window-part} lets one set the
SUT. The first combo-box \includegraphics[height=0.3cm]{combo.jpg} is to
set the SUT file name. One can either:

\begin{enumerate}

\item type directly the name of the file;

\item Use the pull dow menu of the combo-box if the SUT file
  is in the lurette current directory;
\item Use the Browse
  button~\includegraphics[height=0.3cm]{browse-button.jpg} if the SUT is
  not in the current directory. Note that once one has selected with
  the browse button a SUT in a directory that is not the same as the
  current one, the directory of the selected file becomes the new
  current directory.

\end{enumerate}


The second combo box is to set the SUT node.  


The third combo box is to set the compiling mode. The various
compiling modes are described  below (\ref{compiling-mode}).

% ca, je le dis plus tard.
% It can be a {\tt .saofdm}, an {\tt .lus} or a {\tt .c} file.


\subsubsection{The SUT Environment}
The second line in Figure~\ref{main-window-part} lets one set the SUT
environment file. Note that one can set several environment files (cf
lucky manual~\cite{lucky-man}).  In order to add a environment file
to the list without discarding the previously entered files, one has
to type it manually (separating files with at least one blank), or
use the rigth-most browse
button~\includegraphics[height=0.3cm]{browse-plus-button.jpg} decorated
with a ``+'' (which stands for ``add'').

Note that the current directory does not change if an environment
is selected in a directory that is not the same as the current one.

\subsubsection{The Oracle}

The third line in Figure~\ref{main-window-part} lets one set the
oracle.  The only diffrences with the SUT is that setting an oracle is
optional, and that the current directory does not change if an oracle
is selected in a directory that is not the same as the current one.


\subsubsection{The compiling modes}
\label{compiling-mode}
The SUT and the oracle can  be either {\tt .saofdm}, {\tt .lus}, {\tt
  .c}, or {\tt .ml} files.  When the SUT is a {\tt .saofdm}, there is
no ambiguity: the  scade compiler should be used.   However, for {\tt
  .lus} files, lurette  needs to know whether to  use the Verimag V4,
the Verimag V6,  or the Scade compiler (The same  holds for C files).
Users  can specify the  compiler mode  using the  combo boxes  at the
rigth-hand-side       of        the       node       names       (cf,
Figure~\ref{main-window-part}).  They can choose between:

\begin{itemize}
\item {\tt lv4} 
\item {\tt lv6} 
\item {\tt scade}
\item  {\tt ocaml}
\item  {\tt stdin/stdout}
\end{itemize}



More  details  on the  different  compiling  modes  can be  found  in
Sections~\ref{lustre-mode},     ~\ref{c-mode},     ~\ref{ocaml-mode},
and~\ref{stdin-mode}.

%




\subsubsection{The Extra Environment variables window}
\label{extra-var-window}

One can launch the ``Extra Environment Parameters'' window by
clicking on the button just below the oracle line.  A snapshot of
this window is shown on Figure~\ref{extra-var-window}.

\begin{figure}[h]
  \begin{center}
    \begin{minipage}[c]{\textwidth}
      \begin{center}
       \includegraphics[width=0.6\textwidth]{extra-var-window.jpg}
      \end{center}
    \end{minipage}
  \end{center}
  \caption{Setting extras environment variables window.}
  \label{extra-var-window}
\end{figure}


This window is meant to help users to add extras files or paths that
are sometimes necessary for the SUT or the oracle to compile.  Thoses
are used in the Makefile that builds the final test executable.

\begin{itemize}

\item {\tt EXTRA\_SOURCE\_FILES} lets one add C files. For example, the
  scade compiler sometimes generates a file named {\tt
  <sut>\_const.c} that contains the definitions of the some of the
  SUT constants. C files appearing in {\tt EXTRA\_SOURCE\_FILES} are
  compiled and linked with the SUT by lurette.
\item {\tt EXTRA\_LIBS} lets one add libraries ({\tt <file>.a}).
\item {\tt EXTRA\_LIBDIRS} lets one add paths to directories containing librairies.
\item {\tt EXTRA\_INCLUDEDIRS}  lets one add paths to directories containing C header files.
\item {\tt C\_GENERATOR\_FLAG} lets one set options to pass to the C
code generator (lustre2C for Scade Lustre, ec2c for the academic
Lustre).

\end{itemize}


For all those environment variables, one can put several items
(separated by blanks), either manually or using the browse button.



\subsection{The XLurette Test parameters window}

The ``Test Parameters window'' lets one set additional parameters;
one can launch it by clicking on the
\includegraphics[height=0.3cm]{param-button.jpg} button.
%
A snapshot of the Xlurette parameters window is shown on
Figure~\ref{parameters-window}.  In the following, we describe each
of the available Lurette parameters -- note that tool-tips are
displayed if you leave your mouse pointer long enough over each
buttons or boxes in Xlurette GUI.

\begin{figure}
  \begin{center}
    \begin{minipage}[c]{\textwidth}
       \includegraphics[width=\textwidth]{parameters-window.jpg}
    \end{minipage}
  \end{center}
  \caption{The Xlurette parameters window.}
  \label{parameters-window}
\end{figure}


All those parameters can be saved to be used later in a next Xlurette
 session by clicking on button
 \includegraphics[height=0.3cm]{save-button.jpg} (cf
 Figure~\ref{lurette1}).  A file named {\tt .lurette-rc} is then
 created (or updated) in the current directory.


Note also that one can click on the batch button
\includegraphics[height=0.3cm]{batch.jpg} in order to create a file
({\tt <node\_name>.batch}) that contains a command that launch a
lurette test session with the current parameters without launching
Xlurette. This can be very convenient in order to write a battery of
non-regression tests.




\subsubsection{The Test Length}

The Test Length is the number of steps (or cycles) that should be
generated.

\subsubsection{The Test Thickness}
\label{test-thickness}

We call the Test Thickness the number of test vectors that are
generated by the test manager at each step. Note that each vector is
tried w.r.t. the oracle, but only one of them is elected to continue
the testing process, namely, to carry on with the next step.


The test thickness can be changed in several ways:
\begin{enumerate}
 \item The Draw Formula Number ($DF$). From any of the environment
     control points (cf \cite{lucky-man}), several formulas can be
     chosen to generate a SUT input vector. The $DF$ indicates
     whether we try one or all of them.

  \item The Draw Number for Boolean variables ($DB$). For any formula
      that is used to generate a SUT input vector, several Boolean
      values can generally be generated. The $DB$ indicates how many of
      them we do try.

  \item The Draw Number Inside polyhedron ($DI$). For each Boolean
      solution of a formula corresponds a (set of) polyhedron used to
      represent the solutions for the numeric variables. The $DI$
      indicates how many points inside the polyhedron we try at each
      step.

  \item The Draw Number at polyhedron Edges ($DE$). It plays a similar
      role as the $DI$, except that points are drawn with the following
      heuristic: points at vertices, and then on the edges, and then
      inside faces, and so for greater dimensions, are more likely
      to be drawn.

  \item The Draw Number at polyhedron Vertices ($DV$). Points are drawn
      among the polyhedron vertices. One can either set the number of
      vertices to be drawn (Some button), or ask to draw all of them
      (All button).
\end{enumerate}

The Test Thickness ($TT$) is therefore given by the formula:

       $$  TT = DF \times DB \times (1 + DI + DE + DV)$$

Note that if one of the Draw All Formula (via $DF$) or Draw All
Vertices (via $DV$) modes is on, the $TT$ might change from one step to
another.


\subsubsection{The step mode}

The \emph{step Mode} is the policy that is used to draw solutions for
numeric variables for performing the step.  In other words, $DI$,
$DE$, and $DV$ are used for Lurette tries, whereas the step mode is
used for Lurette steps.


\subsubsection{The random engine seed}
The pseudo-random engine needs a seed to be initialised. One can
either let Lurette draw a seed before each run, or set its own one
manually; this can be very useful to replay a run. Note also that, in
the {\tt Random} mode, the integer next to the {\tt Manual} button is
set to automatically drawn seed. This means that if you select that
{\tt Manual} button, the seed will be the one of the previous run.

\subsubsection{Fairness versus efficiency}
 Emphasise the draw fairness over the computation time.  This issue
is detailed in the Section ``The Lucky Numeric solver'' in the Lucky
reference manual~\cite{lucky-man}. 


\subsubsection{Running Lurette step by step}
This mode can be set on and off via (so called) radio-buttons.  When
on, Lurette is run step by step, updating a post-script visualisation
of the Lucky automata (graph and current nodes) at each step. This
requires dot (a graph drawing tool~\cite{dot}) and a post-script
visualiser (gv) to be installed.

\subsubsection{Call sim2chro when Lurette resumes}
This mode can be set on and off via (so called) radio-buttons.


\subsubsection{Put local variable in generated data file}
This mode can be set on and off via (so called) radio-buttons.


\subsubsection{Pre-processor}
One can call a pre-processor (such as {\tt cpp}, or better {\tt
lucky\_cpp} in the {\tt <arch>/bin/} directory) to pre-process Lucky
files. If you do not understand those lines, leave it blank.

\subsubsection{Precision}
The precision sets the number of digit after the dot used by the
environment to perform numeric computations.

\subsubsection{Base RIF file name}
It is the first part of the RIF (see~\ref{rif}) file name used to
 save the generated test data.  The name of that generated file is of
 the shape: {\tt <rif-file-name>-<int>.rif}, where the integer is
 chosen in such a way that the file does not previously exist in the
 current directory. If empty, a default string will be used: it is
 made of the name of the sut, the name of the environment, and the
 test length.



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\subsection{Test Coverage}
\label{coverage}

TODO
%\input{coverage}

%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage
\subsection{Testing Lustre or Scade Programs}
\label{lustre-mode}


In order to test lustre programs, one needs to specify which compiler
should be used (cf Section~\ref{compiling-mode}). For the time being,
3  lustre compilers  are supported:  the Verimag  Lustre  V4 compiler
(lv4);   the    Verimag    Lustre   V6   compiler   (lv6);   the
Esterel-Technologies Lustre compiler (scade).  In the scade mode, one
can also test Scade (.saofdm) programs.

Note that  a different compiling mode  might be used  for the oracle;
but not all the combinations are supported. More precisely, 
\begin{itemize}
\item lv4 and lv6 modes can be mixed arbitrarily
\item In the scade mode for  the SUT, the oracle can be lv4, lv6,
  or scade
\item Otherwise, the SUT and the oracle compiling modes should be the same.
\end{itemize}

\subsection{Testing C Programs}
\label{c-mode}

Since all lustre  (and scade) compilers generates C  code, any C code
that  follows one  of the  lustre compilers  convention can  be used.
One's need to be very familiar with those conventions though.


\subsection{Testing OCaml Programs}
\label{ocaml-mode}

Is is also possible (since  August 2010) to test ocaml programs using
Lurette.  We  suppose that  readers are familiar  with ocaml  in this
section.

\paragraph{The SUT.}

If your SUT is in Ocaml, it must implement the following interface:

 \begin{small}
 \begin{example}
val init : unit -> unit
type var_type = string (* Should be "bool", "int", or "float" *)
val get_input_var_name_and_type : unit -> (string * var_type) list
val get_output_var_name_and_type : unit -> (string * var_type) list
val step : (string * Value.t) list ->  (string, Value.t) Hashtbl.t
val step_try :  (string * Value.t) list ->  (string, Value.t) Hashtbl.t
 \end{example}
 \end{small}

Of course, the  outputs of {\tt get\_input\_var\_name\_and\_type} and
{\tt  get\_output\_var\_name\_and\_type}  should  be consistent  with
{\tt step} and  {\tt step\_try}, i.e.  , the  arity, and the variable
names and types should match.

{\tt step\_try}  is supposed  to save the  current state of  the SUT,
perform a  {\tt step},  and restore the saved state.   Hence {\tt step\_try}
is the same as {\tt step} for stateless programs.



\paragraph{The oracle.}

Similarly,  oracles written  in  Ocaml must  implement the  following
interface:

 \begin{small}
 \begin{example}
val init : unit -> unit
type var_type = string
val get_input_var_name_and_type : unit -> (string * var_type) list
val get_output_var_name_and_type: unit -> (string * var_type) list
val step: (string * Value.t) list -> (string, Value.t) Hashtbl.t -> bool * Var.subst list
val step_try: (string * Value.t) list -> (string, Value.t) Hashtbl.t -> bool * Var.subst list
 \end{example}
 \end{small}
     
{\tt step} (and  {\tt step\_try}) should return a pair  made of the result
of the oracle (success or failure) and the list of oracle outputs.


Note that the oracle step takes as input the SUT inputs, and then the
SUT outputs.   Hence you should make  sure that the  oracle inputs is
made  of the  SUT inputs  and the  SUT outputs.  In other  words, you
should satisfy the following assertion:

 \begin{small}
 \begin{example}
 assert(
   List.sort compare
   (TheSut.get_input_var_name_and_type())@(TheSut.get_output_var_name_and_type())
  =
    List.sort compare (TheOracle.get_input_var_name_and_type ())
 )
 \end{example}
 \end{small}


\paragraph{nb.}
Like in other  modes, if our ocaml programs  is splited into several
files, or  if its uses libraries,  one need to  set appropriately the
parameters  in  the \emph{Extra Environment  variables window}  (cf
Section~\ref{extra-var-window}).

\subsection{Testing any Programs (using stdin/stdout and RIF conventions)}
\label{stdin-mode}

There  exists a  versatile (and  rather experimental)  mode,  that is
language-agnostic.  It can test  any (executable) programs that reads
and writes  its IO on its  standard inputs and outputs  using the RIF
conventions  (cf  Appendix~\ref{rif}).  In  this mode,  lurette  will
launch a  system call using  the string written  in the SUT  (and the
oracle) box. It can be a command with parameters.


For example,  one can write  {\tt "ecexe heater\_control.ec"}  in the
SUT box. Indeed, the {\tt ecexe} ec files interpreter (present in the
Lustre  V4  distribution)  reads  and  writes  data  on  stdin/stdout
following the RIF conventions.
%
If you  have a data file  that follows the  RIF convention, something
like {\tt "cat my\_data\_file.rif"} ougth to work also.


\paragraph{Watch out:} the {\tt stdin/stdout} mode,
the link between  the SUT, the environment and the  oracle is done by
{\bf variable positions}, whereas it  is done by {\bf variable names}
in all the other modes.


Note    also    that    the    test    thickness    parameters    (cf
\ref{test-thickness}) are (currently) ignored in this mode.

%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage

\subsection{Installation and configuration issues}
\label{install}
\label{supported-arch}



Lurette has been tested with the following architectures:
\begin{itemize}
\item Solaris/Sparc.
\item Linux/PC.
\item Windows/PC. 
\item Mac os/PC and powermac.
\end{itemize}


In order to use Lurette, you need
\begin{itemize}
\item gcc 
\item gnuplot V3.8i or higher
\item dot (graphviz)
\item gmp (GNU Multiple Precision arithmetic library)
\end{itemize}


\paragraph{The short story.} Hopefully, you 
should only need to untar the package and run the {\tt INSTALL}
script.

\begin{alltt}
     > tar xvfz lurette\version.tgz 
     > cd lurette\version
     > ./INSTALL
\end{alltt}

The {\tt xlurette} tool is in the {\tt lurette\version/<arch>/bin/}
directory, therefore you might want to add it in your {\tt PATH} env
variable.

You can check that the installation works correctly by going to
the {\tt test} directory and launch a {\tt make test} command in your
shell.

\paragraph{The long story.}
If you run into problems during the use of Xlurette, it might be useful
for you to understand a little bit how things are organised to try to
figure out how problems might be fixed.

The INSTALL script generates the {\tt
lurette\version/<arch>/set\_env\_var} file, that defines various
environment variables. Xlurette evaluates this file before running;
therefore, it might be useful for you to check the content of that
file to see whether the information it contains seems correct.
%
Be aware that this file will be overridden if you run the {\tt INSTALL}
script again.

Another important file is {\tt
lurette\version/<arch>/Makefile.lurette}. It is the makefile that is
used to generate the final executable that Lurette runs. If Lurette
runs fail, it might be useful for you to check the content of that
file, in particular in you use a scade version different from the
4.1.4, which is the only one that has been tried.

\paragraph{Environment variables.}

Here is the list of all the environment variables that users can set
to override default values. The default values are set by the INSTALL
script. You can consult them by looking at the {\tt
lurette\version/<arch>/set\_env\_var} file.



\newcommand{\envvar}[3]{{\tt \mbox{#1:}} #3. 
\ifthenelse{\equal{#2}{}}{}{ Its default value is {\tt "#2"}.}}

\begin{itemize}

\item \envvar{PS\_VIEWER}{gv}{to set the tool used 
  to visualize post-script files}

\item \envvar{AWK}{}{to override the awk that is used}

\item \envvar{DOT}{dot}{to override the dot (a graph drawing tool) that is used}

\item \envvar{SIM2CHRO}{}{to override the rif viewer that is used}

\item \envvar{LUS2EC}{lus2ec}{to override the lustre to ec verimag compiler}

\item \envvar{LUS2LIC}{lus2lic}{to override the lustre V6 verimag compiler}

\item \envvar{EC2C}{ec2c}{to override the ec to C verimag compiler}

\item \envvar{SCADE2LUSTRE}{scade2lustre}{to override the scade to lustre compiler}

\item \envvar{SCADE\_CG}{scade\_cg}{to override the scade code generator}

\item \envvar{LUSTRE2C}{lustre2c}{to override the lustre to C scade compiler}

\item \envvar{SCADE\_COMPIL\_OPTION}{ -noexp @ALL@ }{to override 
  additionnal options to be given to the scade compilers}

%\item \envvar{}{}{}
\end{itemize}

Indeed, it is sometimes useful to override those default values to
explicitely specify the full path of tools that are used by Lurette.


%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage


\input{fault-tolerant-tut}



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\mynewpage
\input{english.macros}
\bibliographystyle{alpha}
\bibliography{mycommontex}

%\bibliography{../zebib}

%---------------------------------------------------------------------
%---------------------------------------------------------------------
\mynewpage
% \section{Architecture of the tool}
\appendix


\section{The fault-tolerant heater controller} % full listing}

\label{heater-control-lus}

% \begin{figure}[htb]
\begin{small}
 \begin{example}
 \input{heater_control}
 \end{example}
 \end{small}
 % \caption{The fault-tolerant heater controller full listing}
 % \end{figure}


%---------------------------------------------------------------------
%---------------------------------------------------------------------
\mynewpage
\section{Lurette Architecture -- Components Description}
\label{lurette-components}



In this Appendix, we present the different tools, resource files and
libraries that are involved in the production of the final
executable that performs the testing. We also describe how the
SUT, the test Oracle, and the SUT environment are be connected one
to each other.



\subsection{Interfacing Lurette with the SUT} 
\label{sut-interface}

In order to run the test, as far as the SUT is concerned, Lurette
needs to be able to:
\begin{enumerate}
\item read/write its input/output (\code{read\_o} and \code{write\_i});
\item perform a try, namely, to have a mean to save and restore the
  SUT state (\code{try}).
\item perform a step (\code{step});
\end{enumerate}



The two languages we support are the academic Lustre (Verimag), and
Scade (Esterel-Technologies). Both compiles into C code, but with
distinct interfaces in the way the 4 interfaces functions
(\code{read\_o}, \code{write\_i}, \code{step} and \code{try}) are to
be performed. Moreover, Lurette should be able to be used to test any
reactive system code, for which compilers would certainly have
(similar but) different interfaces. For that reason, the calls to the
SUT interface functions should not be hard-coded: Lurette calls an
abstract interface, that is implemented for each different SUT code
compiler (namely, for the time being, the academic Lustre compiler
and the Scade one).



\begin{figure}[h]
\begin{center}
  \begin{minipage}[c]{0.8\textwidth}
      \includegraphics[width=\textwidth]{objs/obj-code-gen}
  \end{minipage}
 \end{center}
%  \epsfig{figure=obj-code-gen.eps, width=13cm}
  \caption{Object Code Generation for the SUT.}
  \label{obj-code-gen}
\end{figure}

The implementation of this abstract interface for the Lustre and the
Scade compilers is materialised in Figure~\ref{obj-code-gen} by the
\term{gen\_stubs\_lustre} and \term{gen\_stubs\_scade} tools.  The
generated C code is parsed in order to retrieve the input and output
variable names and types.  The generated file \verb+sut_stubs.c+
implements the abstract interface that provides to
\term{LURETTE\_EXE} the interface functions \code{read\_o},
\code{write\_i}, \code{step} and \code{try}.

Figure~\ref{obj-code-gen} also makes explicit the usual Lustre /
Scade code compilation process into c (\code{lustre2c} /
\code{Scade2c}), and the object code generation with a C compiler
(\code{cc}).

\subsection{Interfacing Lurette with the Oracle} 
\label{oracle-interface}
In the current scheme, the oracle is written in the same language as
the SUT (Lustre or Scade). Therefore, the interfacing work is exactly
the same as for the SUT.


\subsection{Interfacing Lurette with the Environment simulator}
\label{lucky-interface} 
The main part of the Lurette implementation effort lies in the Lucky
programs simulation.  At this level of the description, we only focus
on the description of the connection between components; we therefore
suppose that we have \code{read\_o}, \code{write\_i}, \code{step} and
\code{try} functions for the environment too.


An outline of the different components involved in the final
executable file \term{LURETTE\_EXE} is provided in
Figure~\ref{components-diagram}. The object code files \code{sut.o}
and \code{sut\_stubs.o} as well as \code{oracle.o} and
\code{oracle\_stubs.o} are linked with the Lucky ({\tt \green {env.luc}})
file interpreter library \code{lucky\_lib.a}.

Note the \code{lucky\_lib.a} uses two external libraries: a Binary
Decision Diagram library~\cite{cudd} (\code{bdd.a}) to deals with Boolean
variables; and a convex Polyhedron Library (\code{polyhedron.a}) to
deal with numeric variables~\cite{polka}.
 

\begin{figure}
  \begin{center}
    \begin{minipage}[c]{0.8\textwidth}
      \includegraphics[width=\textwidth]{objs/components-diagram}
    \end{minipage}
  \end{center}
  \caption{Lurette Components diagram.}
  \label{components-diagram}
\end{figure}


%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\section{The RIF conventions}
\label{rif}

RIF stands for \emph{Reactive Input Format}. It is the format used by
the synchronous Verimag tools for writing and reading sequences of
input and output data vectors. We recall in this section what this format
looks like.

\paragraph{Data.} A RIF file is a sequence of data values separated
by spaces, newlines, horizontal tabulations, carriage returns, line
feed and form feeds. A data value can be either an integer, a
floating-point or a Boolean ({\tt t}, {\tt T}, or {\tt 1} stands for
{\tt true} ; {\tt f}, {\tt F} or {\tt 0} stands for {\tt false}).


\paragraph{Comments.}
Single line comments are introduced by the two character \kwd{\#} and
terminated by a new line.  Multi-line comments are introduced by the
two characters \kwd{@\#}, and terminated by the two characters
\kwd{\#@}.



\paragraph{Pragmas.}
Pragmas are special kinds of comments, that migth (or not) be taken into
account by tools  that reads RIF data. One-line pragmas have the
form \kwd{\#pragma\_ident ... }, and multi-line pragmas the form
\kwd{@\#pragma\_ident ... \#@}.
%
The most common pragmas used by verimag tools are (using BNF
notation):

\begin{itemize}


\item \kwd{@\#inputs} (\nt{var name} \term{:} \nt{var type})+ \kwd{\#@}
or
\item \kwd{\#inputs} (\nt{var name} \term{:} \nt{var type})+
to
declare the list of input variable names and types;


\item \kwd{@\#outputs} (\nt{var name} \term{:} \nt{var type})+ \kwd{\#@}
or
\item \kwd{\#outputs} (\nt{var name} \term{:} \nt{var type})+ 
to declare the list of output variable names and types;


\item \kwd{@\#locals} (\nt{var name} \term{:} \nt{var type})+ \kwd{\#@}
or 
\item \kwd{\#locs} to indicate that the following data correspond to local variables;
  to declare the list of local variable names and types;


\item \kwd{\#outs}, to indicate that the following data correspond to output variables;

\item \kwd{\#step } \term{int}, to indicate that a new step is
starting, and that the following data correspond to input variables.



\end{itemize}

Note that those pragmas are necessary for RIF file viewers such as
{\tt sim2chro} and {\tt gnuplot-rif} to work properly.




A RIF file example is provided in Figure~\ref{rif-exemple}; it
corresponds to the timing diagram of Figure~\ref{sensors-worning-pdf}.

\begin{figure}[h]
\begin{alltt}
  # seed = 97040004
     #program "lurette chronogram (degradable-sensors.luc) "
     \kwd{#@inputs}
     "T":real
     "T1":real
     "T2":real
     "T3":real
     \kwd{@#}
     \kwd{#@locals}
     "degradable-sensors__cpt":int
     "degradable-sensors__eps":real
     "degradable-sensors__eps1":real
     "degradable-sensors__eps2":real
     "degradable-sensors__eps3":real
     \kwd{@#}
     \kwd{#@outputs}
     "Heat_on":bool
     \kwd{@#}
     \kwd{#step} 1
     7.00 7.00 7.00 7.00 \kwd{#outs} T 
     \kwd{#locs} 0 0.08 -0.05 -0.05 0.10 
     \kwd{#step} 2
     7.13 7.20 7.16 7.18 \kwd{#outs} T 
     \kwd{#locs} 1 0.13 0.07 0.03 0.05 
     \kwd{#step} 3
     7.27 7.37 7.27 7.18 \kwd{#outs} T 
     \kwd{#locs} 2 0.14 0.10 -0.00 -0.09 
     \kwd{#step} 4
     7.45 7.47 7.38 7.36 \kwd{#outs} T 
     \kwd{#locs} 3 0.18 0.02 -0.07 -0.09 
     \kwd{#step} 5
     7.59 7.68 7.61 7.56 \kwd{#outs} T 
     \kwd{#locs} 4 0.14 0.09 0.02 -0.03 
     \kwd{#step} 6
     7.65 7.58 7.64 7.55 \kwd{#outs} T 
     \kwd{#locs} 5 0.06 -0.06 -0.01 -0.09 
     \kwd{#step} 7
     7.84 7.91 7.94 7.90 \kwd{#outs} T 
     \kwd{#locs} 6 0.20 0.07 0.10 0.06 
     \kwd{#step} 8
     8.00 8.07 8.00 8.09 \kwd{#outs} T 
     \kwd{#locs} 7 0.15 0.07 0.00 0.09 
     \kwd{#step} 9
     8.12 8.09 8.17 8.16 \kwd{#outs} T 
     \kwd{#locs} 8 0.13 -0.03 0.05 0.04 
     \kwd{#step} 10
     8.26 8.29 8.30 8.20 \kwd{#outs} T 
\end{alltt}
\caption{A RIF file example.}
\label{rif-exemple}
\end{figure}

\end{document}
